%define sel_modn  selinux-policy-addon
%define sel_modv  0.2.7


Summary:          An open source antivirus engine
Name:             clamav
Version:          0.98.1
Release:          1%{?dist}%{?pext}
License:          GPL
Group:            System Environment/Daemons
Source0:          http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
Source1:          %{name}-milter.init
Source2:          %{name}-milter.sysconfig
Source3:          clamd.init
Source4:          clamd.sysconfig
Source5:          freshclam.init
Source6:          freshclam.sysconfig
Source7:          %{name}.logrotate
Source10:         %{name}-database-20140127.tar.gz
Patch0:           %{name}-0.98.1-config.patch
URL:              http://www.%{name}.net/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           ClamAV
Requires:         %{name}-lib = %{version}-%{release}
BuildRequires:    bzip2-devel check-devel ncurses-devel
BuildRequires:    sendmail-devel >= 8.12 zlib-devel
BuildArch:        i486 x86_64

%description
ClamAV is an open source antivirus engine designed for detecting Trojans,
viruses, malware and other malicious threats. It is the de facto standard
for mail gateway scanning. It provides a high performance mutli-threaded
scanning daemon, command line utilities for on demand file scanning, and
an intelligent tool for automatic signature updates. The core library
provides numerous file format detection mechanisms, file unpacking support,
archive support, and multiple signature languages for detecting threats.


%package          db
Summary:          The virus database for ClamAV
Group:            Applications/Databases
Provides:         %{name}-data = %{version}-%{release}
Provides:         %{name}-update = %{version}-%{release}
Requires:         %{name}-lib = %{version}-%{release}
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service

%description      db
The %{name}-db package contains the actual virus database and the database
updater for ClamAV.


%package          devel
Summary:          Development tools for ClamAV
Group:            Development/Libraries
Provides:         libclamav-devel = %{version}-%{release}
Requires:         %{name}-lib = %{version}-%{release}
Requires:         bzip2-devel libstdc++-devel pkgconfig
Requires:         zlib-devel

%description      devel
The %{name}-devel package contains the libraries and header files for
developing software using ClamAV.


%package          doc
Summary:          The ClamAV documentation
Group:            Documentation

%description      doc
The %{name}-doc package contains the complete ClamAV documentation in HTML
and PDF format.


%package          lib
Summary:          The ClamAV core libraries
Group:            System Environment/Libraries
Provides:         libclamav = %{version}-%{release}
Requires:         %{name}-db = %{version}-%{release}
Obsoletes:        %{name}-libs < %{version}-%{release}

%description      lib
The %{name}-lib package contains all ClamAV core runtime libraries used by
ClamAV itself and other software.


%package          milter
Summary:          The Milter interface for ClamAV
Group:            System Environment/Daemons
Requires:         %{name} = %{version}-%{release}
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service

%description      milter
The %{name}-milter package contains the sendmail milter interface for ClamAV.


%package          server
Summary:          The ClamAV scanning daemon
Group:            System Environment/Daemons
Provides:         clamd = %{version}-%{release}
Provides:         %{name}-scanner = %{version}-%{release}
Requires:         %{name} = %{version}-%{release}
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service

%description      server
The %{name}-server package contains the on-demand scanning daemon for ClamAV.


%package          server-selinux
Summary:          SELinux support for %{name}-server
Group:            System Environment/Base
Requires:         %{name}-server = %{version}-%{release}
Requires:         %{sel_modn} >= %{sel_modv}
Requires(post):   %{_sbindir}/selinuxenabled /sbin/fixfiles

%description      server-selinux
The %{name}-server-selinux package enables %{name}-server to work with SELinux.


%package          static
Summary:          Static libraries for ClamAV
Group:            Development/Libraries
Requires:         %{name}-devel = %{version}-%{release}

%description      static
The %{name}-static package contains the statically linkable libraries for
ClamAV.


%prep
%setup -q -a 10
%patch0 -p1


%build
BUILDFLAGS="-fno-strict-aliasing -Wno-unused"

%configure \
	CFLAGS="${RPM_OPT_FLAGS} ${BUILDFLAGS}"       \
	CXXFLAGS="${RPM_OPT_FLAGS} ${BUILDFLAGS}"     \
	--sysconfdir=%{_sysconfdir}/%{name}           \
	--localstatedir=%{_localstatedir}/run/%{name} \
	--enable-shared                               \
	--enable-static                               \
	--enable-check                                \
	--disable-rpath                               \
	--enable-milter                               \
	--disable-clamav                              \
	--enable-no-cache                             \
	--enable-dns-fix                              \
	--enable-bigstack                             \
	--enable-readdir_r                            \
	--enable-clamdtop                             \
	--enable-llvm                                 \
	--with-iconv                                  \
	--with-dbdir=%{_localstatedir}/lib/%{name}

%{__make} V=1 %{?_smp_mflags}


%check
%{__make} check


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/{%{name},logrotate.d,sysconfig}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_prefix}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/{lib,log,run}/%{name}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__mv}      -f      ${RPM_BUILD_ROOT}%{_bindir}/freshclam ${RPM_BUILD_ROOT}%{_sbindir}

%{__install} -m 0755 %{SOURCE1}   ${RPM_BUILD_ROOT}%{_initrddir}/%{name}-milter
%{__install} -m 0755 %{SOURCE3}   ${RPM_BUILD_ROOT}%{_initrddir}/clamd
%{__install} -m 0755 %{SOURCE5}   ${RPM_BUILD_ROOT}%{_initrddir}/freshclam

%{__install} -m 0644 %{SOURCE2}   ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}-milter
%{__install} -m 0644 %{SOURCE4}   ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/clamd
%{__install} -m 0644 %{SOURCE6}   ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/freshclam

%{__install} -m 0644 %{SOURCE7}   ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

for FILE in %{name}-milter clamd freshclam; do
  %{__mv}    -f      ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/${FILE}.conf.sample \
		     ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/${FILE}.conf

  touch              ${RPM_BUILD_ROOT}%{_localstatedir}/log/%{name}/${FILE}.log
done

%{__rm}      -f      ${RPM_BUILD_ROOT}%{_libdir}/lib*.so.{?,??}


%pre db
if ! getent group  %{name} >/dev/null 2>&1; then
  /usr/sbin/groupadd -r %{name}
fi
if ! getent passwd clamdb  >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -g %{name}       \
	-d %{_localstatedir}/lib/%{name} \
	-c "ClamAV Database user" -M     \
	-s /sbin/nologin clamdb
fi
if ! getent passwd %{name} >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -g %{name}       \
	-d %{_localstatedir}/run/%{name} \
	-c "ClamAV Service user" -M      \
	-s /sbin/nologin %{name}
fi
exit 0			# Always pass


%post db
/sbin/chkconfig --add freshclam

%post lib -p /sbin/ldconfig

%post milter
/sbin/chkconfig --add %{name}-milter

%post server
/sbin/chkconfig --add clamd

%post server-selinux
if /usr/sbin/selinuxenabled && [ -e /selinux/policyvers ]; then
  /sbin/fixfiles -R %{name}-server restore
fi


%preun db
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service freshclam stop >/dev/null 2>&1
  /sbin/chkconfig --del freshclam
fi

%preun milter
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{name}-milter stop >/dev/null 2>&1
  /sbin/chkconfig --del %{name}-milter
fi

%preun server
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service clamd stop >/dev/null 2>&1
  /sbin/chkconfig --del clamd
fi


%postun db
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service freshclam condrestart >/dev/null 2>&1 || :
fi

%postun lib -p /sbin/ldconfig

%postun milter
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{name}-milter condrestart >/dev/null 2>&1 || :
fi

%postun server
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service clamd condrestart >/dev/null 2>&1 || :
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc AUTHORS BUGS ChangeLog FAQ
%doc INSTALL NEWS README UPGRADE
%doc etc/clamd-client.conf
%{_bindir}/clambc
%{_bindir}/clamconf
%{_bindir}/clamdscan
%{_bindir}/clamdtop
%{_bindir}/clamscan
%{_bindir}/sigtool
%{_mandir}/man1/clambc.1*
%{_mandir}/man1/clamconf.1*
%{_mandir}/man1/clamdscan.1*
%{_mandir}/man1/clamdtop.1*
%{_mandir}/man1/clamscan.1*
%{_mandir}/man1/sigtool.1*

%files db
%defattr(-,root,root)
%attr(750,root,%{name}) %dir %{_sysconfdir}/%{name}
%attr(600,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/freshclam.conf
%{_initrddir}/freshclam
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) %{_sysconfdir}/sysconfig/freshclam
%{_sbindir}/freshclam
%{_mandir}/man1/freshclam.1*
%{_mandir}/man5/freshclam.conf.5*
%attr(755,clamdb,%{name}) %dir %{_localstatedir}/lib/%{name}
%attr(644,clamdb,%{name}) %config(noreplace) %verify(not md5 size mtime) %{_localstatedir}/lib/%{name}/*.cvd
%attr(750,%{name},%{name}) %dir %{_localstatedir}/log/%{name}
%attr(640,clamdb,%{name}) %ghost %{_localstatedir}/log/%{name}/freshclam.log
%attr(755,%{name},%{name}) %dir %{_localstatedir}/run/%{name}

%files devel
%defattr(-,root,root)
%doc %dir examples
%{_bindir}/%{name}-config
%{_includedir}/%{name}.h
%{_libdir}/libclamav.la
%{_libdir}/libclamav.so
%{_libdir}/libclamunrar.la
%{_libdir}/libclamunrar.so
%{_libdir}/libclamunrar_iface.la
%{_libdir}/libclamunrar_iface.so
%{_libdir}/pkgconfig/libclamav.pc

%files doc
%defattr(-,root,root)
%doc docs/{html,*.pdf}

%files lib
%defattr(-,root,root)
%doc COPYING*
%{_libdir}/libclamav.so.*
%{_libdir}/libclamunrar.so.*
%{_libdir}/libclamunrar_iface.so.*

%files milter
%defattr(-,root,root)
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/%{name}-milter.conf
%{_initrddir}/%{name}-milter
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}-milter
%{_sbindir}/%{name}-milter
%{_mandir}/man5/%{name}-milter.conf.5*
%{_mandir}/man8/%{name}-milter.8*
%attr(640,%{name},%{name}) %ghost %{_localstatedir}/log/%{name}/%{name}-milter.log

%files server
%defattr(-,root,root)
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/clamd.conf
%{_initrddir}/clamd
%config(noreplace) %{_sysconfdir}/sysconfig/clamd
%{_sbindir}/clamd
%{_mandir}/man5/clamd.conf.5*
%{_mandir}/man8/clamd.8*
%attr(640,%{name},%{name}) %ghost %{_localstatedir}/log/%{name}/clamd.log

%files server-selinux
%defattr(-,root,root)

%files static
%defattr(-,root,root)
%{_libdir}/libclamav.a
%{_libdir}/libclamunrar.a
%{_libdir}/libclamunrar_iface.a


%changelog
* Mon Jan 27 2014 Peter Pramberger <peterpramb@member.fsf.org> - 0.98.1-1
- New version (0.98.1)

* Wed Oct 09 2013 Peter Pramberger <peterpramb@member.fsf.org> - 0.98-1
- New version (0.98)

* Sun May 12 2013 Peter Pramberger <peterpramb@member.fsf.org> - 0.97.8-1
- New version (0.97.8)

* Fri Mar 29 2013 Peter Pramberger <peterpramb@member.fsf.org> - 0.97.7-1
- New version (0.97.7)

* Sat Sep 22 2012 Peter Pramberger <peterpramb@member.fsf.org> - 0.97.6-1
- New version (0.97.6)

* Sat Jun 23 2012 Peter Pramberger <peterpramb@member.fsf.org> - 0.97.5-1
- New version (0.97.5)

* Mon Mar 19 2012 Peter Pramberger <peterpramb@member.fsf.org> - 0.97.4-1
- New version (0.97.4)

* Fri Oct 21 2011 Peter Pramberger <peterpramb@member.fsf.org> - 0.97.3-1
- New version (0.97.3)

* Sun Sep 04 2011 Peter Pramberger <peterpramb@member.fsf.org> - 0.97.2-1
- Initial build
